# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

# 2.0.0-beta.52 (2021-05-20)

### Bug Fixes

- **antd:** fix form-item style ([8ee6c43](https://github.com/alibaba/formily/commit/8ee6c4314c0710985a39078be854e688c91acf44))
- **core:** fix observable componentProps ([dfe2e21](https://github.com/alibaba/formily/commit/dfe2e2131b70c3eab14f101c9a7c2376393c84a3))
- **core:** fix the effects of IFormProps losing generic type ([#1418](https://github.com/alibaba/formily/issues/1418)) ([ee8d118](https://github.com/alibaba/formily/commit/ee8d118de71070b6ce03ed076508737b5cc4a634))
- **project:** fix typings ([47eb9cd](https://github.com/alibaba/formily/commit/47eb9cd5af5c500701c66824422eb30f52eee3b3))
- **react:** fix createSchemaField empty options ([1656373](https://github.com/alibaba/formily/commit/165637331b3a39a27c42a4af5beedbd9cbdd8fbb))
- **react:** fix SchemaField missing scope from options ([#1462](https://github.com/alibaba/formily/issues/1462)) ([470b3aa](https://github.com/alibaba/formily/commit/470b3aaf59643ceb24ff8ffd6bbd991a9c0cb838))
- **react:** fix typings ([146cc8d](https://github.com/alibaba/formily/commit/146cc8d006b3dc993eefd8d87637ad6b91b3bd72))
- **react:** fix typings ([d6ccde9](https://github.com/alibaba/formily/commit/d6ccde9b174d0c833e10943a5ce10f6bd8c504f9))
- **react/vue:** fix onChange can not pass to voidField's component props. ([#1264](https://github.com/alibaba/formily/issues/1264)) ([1764f6e](https://github.com/alibaba/formily/commit/1764f6ee7825480bc3813dbeae7e13eb5d6d6723))

### Features

- **antd:** support form-tab and form-collapse ([0c751fe](https://github.com/alibaba/formily/commit/0c751fea6723844ce4a691cc25c00cb10122d9d1))
- **core:** add generic type support for form ([#1400](https://github.com/alibaba/formily/issues/1400)) ([29ef93f](https://github.com/alibaba/formily/commit/29ef93f15dc73470d1ffeab40561208c8e282866))
- **core:** support enableUnmountRemoveNode/disableUnmountRemoveNode API ([8f99e5b](https://github.com/alibaba/formily/commit/8f99e5b32ae0a1e342945dfd4ab8ff393776c684))
- **core:** support validate ([b41fbe6](https://github.com/alibaba/formily/commit/b41fbe664aa41d20345f5ef020344c04a4268dd1))
- **core:** update ([d02f495](https://github.com/alibaba/formily/commit/d02f4954533f9133e416d26a40c3090dcc6985dc))
- **core:** update ([3da71d8](https://github.com/alibaba/formily/commit/3da71d867f7fda433b32d564f919d29886b545ac))
- **core:** update query ([d3fd6a7](https://github.com/alibaba/formily/commit/d3fd6a728af662ba65ca6de5076c6904ea9d5b66))
- **core:** update typings ([eb526c1](https://github.com/alibaba/formily/commit/eb526c160e480b67def46792a61533e7851e82aa))
- **core:** update typings ([6c84eab](https://github.com/alibaba/formily/commit/6c84eabab1ad0330431d58c0700e2648dbba29a0))
- **core:** update typings ([473e5bc](https://github.com/alibaba/formily/commit/473e5bc33ae6c7380fee309470366cec3b1f9b3d))
- **core:** update typings ([42ad687](https://github.com/alibaba/formily/commit/42ad6877abaea71d58cbfdd38bc280e727fd126d))
- **json-schema:** add registerPolyfills/enablePolyfills api ([fd5eac5](https://github.com/alibaba/formily/commit/fd5eac5f1a1c38fe6e3687a9cce664c621fea7c0))
- **json-schema:** support alias style for x-reactions.dependencies ([b84a624](https://github.com/alibaba/formily/commit/b84a624480e44be405b8ea8d58261d322a04dc19))
- **project:** improve code ([add85f0](https://github.com/alibaba/formily/commit/add85f074796bd44cbbe9ae634c55be17b29e444))
- **project:** improve code ([3f81bf0](https://github.com/alibaba/formily/commit/3f81bf0f7b963f49ee2d8b6dc7d237a417cddd74))
- **project:** improve code ([e586614](https://github.com/alibaba/formily/commit/e586614016371ca0e4c43d2a5a45ae7bbee37647))
- **project:** improve code ([91e884a](https://github.com/alibaba/formily/commit/91e884a321629aef677583e91678aa4527d269e0))
- **project:** improve code ([f3552f7](https://github.com/alibaba/formily/commit/f3552f72f3fb90771547b084e656385f33b92b75))
- **project:** improve code ([2c79cbb](https://github.com/alibaba/formily/commit/2c79cbb1166c6699aefbeeb28a882ed191ee7065))
- **project:** improve code ([739b803](https://github.com/alibaba/formily/commit/739b803dcd5f7bd3155aa639ba3241c84c2f770e))
- **project:** improve code ([5438205](https://github.com/alibaba/formily/commit/54382054f16b30a4dc7aaabba901978eab2c6c80))
- **project:** improve code ([71ab367](https://github.com/alibaba/formily/commit/71ab3675a942d9e8d25247793a06515092fbff1f))
- **project:** move SchemaField to @formily/react ([a8bf514](https://github.com/alibaba/formily/commit/a8bf5147f9ae63df6fb833d3f8df028d340e44e8))
- **project:** remove mobx-react-lite ([7078616](https://github.com/alibaba/formily/commit/70786169a2e6fc042355590c2cbdc8ab03b8293a))
- **project:** rename fullfill=>fulfill ([0b794f1](https://github.com/alibaba/formily/commit/0b794f1121ab622e454f9ccca7229c56bf0a9b87))
- **project:** rename fullfill=>fulfill ([1a955dd](https://github.com/alibaba/formily/commit/1a955dd6abbd586ae8e0c0a40386fd7d5b952c6c))
- **project:** support field.dataSource ([74b7b1f](https://github.com/alibaba/formily/commit/74b7b1f8e3f6786608606a556c0f6d3c62eff08c))
- **react:** add context cleaner to FormProvider ([b1eab98](https://github.com/alibaba/formily/commit/b1eab98a779051ac403b0825b2217ce23467a744))
- **react:** connect add hoistNonReactStatics ([9b68f1e](https://github.com/alibaba/formily/commit/9b68f1ef6f14075587c4958139ffdb76d59dd52f))
- **react:** improve code ([eeee6f8](https://github.com/alibaba/formily/commit/eeee6f88166d16ba9d313e8dbab8cc61aa4b8a58))
- **react:** improve code ([83f8ac4](https://github.com/alibaba/formily/commit/83f8ac46034ec0722affc54477bd905d3f3538e2))
- **react:** improve code ([71a2bd5](https://github.com/alibaba/formily/commit/71a2bd5272066c6e844666303f523545dc50dd34))
- **react:** improve code ([8880c51](https://github.com/alibaba/formily/commit/8880c51535d77052e9768ee061f55ad24ad1eede))
- **react:** improve code ([783d18c](https://github.com/alibaba/formily/commit/783d18c3cf6c916af7f6fcd987aa8c769228d6fc))
- **react:** improve code ([52acbb9](https://github.com/alibaba/formily/commit/52acbb935978790a1ebac621035b1765ae02d727))
- **react:** improve code ([b123158](https://github.com/alibaba/formily/commit/b123158a77160fb66cf70b91e3ddfcf56e21f93c))
- **react:** improve code ([48c47c9](https://github.com/alibaba/formily/commit/48c47c9c2e23543058c4d3157d2de748d5e239cc))
- **react:** improve code ([4eb89da](https://github.com/alibaba/formily/commit/4eb89da8383d2db43af64d4c01cc764b9b99a125))
- **react:** improve code ([7f9fb94](https://github.com/alibaba/formily/commit/7f9fb947ce6f4792c2fc121e29f6b7772d6a15e5))
- **react:** improve code ([152b93e](https://github.com/alibaba/formily/commit/152b93e2e642530f640323b5b1455830c506396a))
- **react:** improve code ([8d3b96e](https://github.com/alibaba/formily/commit/8d3b96e9e10544921813ebaace7bca9e62348824))
- **react:** improve code ([315b7dd](https://github.com/alibaba/formily/commit/315b7ddf83ebbf26318dfe9a0aa628a8aad8bf0b))
- **react:** improve code ([2c6d9e4](https://github.com/alibaba/formily/commit/2c6d9e409c81eca8f35565e471d235c795a052aa))
- **react:** improve code ([92ff505](https://github.com/alibaba/formily/commit/92ff50513d4c28e7406742f13cf20cbb7db1200a))
- applicable less and scss to vite ([#1187](https://github.com/alibaba/formily/issues/1187)) ([fb01176](https://github.com/alibaba/formily/commit/fb011768e863c56eeed8f9826932ae72c2bd0acf))
- **react:** support scope components api for SchemaField ([307e88f](https://github.com/alibaba/formily/commit/307e88facf7d22907579fb81e8968baf9bb4fd22))
- **react:** update mapProps ([7940cab](https://github.com/alibaba/formily/commit/7940cab81965817eb9375469ecd94d55d3356c20))
- **react-logic-diagram:** update docs ([859feed](https://github.com/alibaba/formily/commit/859feedf38c3461f7c011c10dfc4189d19ffad41))
- **react-schema-field:** improve code ([692c3d0](https://github.com/alibaba/formily/commit/692c3d0099079f112bcc62afad648db931c26023))
- **schema-field:** move transformer to json-schema package ([69677e1](https://github.com/alibaba/formily/commit/69677e1ddc34a6914166e61fd4929bdd5dc0aed2))

### Performance Improvements

- **json-schema:** improve performace and fix sahred schema ref ([d4e9335](https://github.com/alibaba/formily/commit/d4e93357b3e21516bdc6b1fe5d415a54d3ac2914))

## 1.3.4 (2020-10-09)

## 1.3.3 (2020-09-21)

## 1.3.2 (2020-09-07)

## 1.3.1 (2020-08-20)

### Features

- **layout/docs:** update docs and fix layout ([#1003](https://github.com/alibaba/formily/issues/1003)) ([16be58c](https://github.com/alibaba/formily/commit/16be58cc3af42606b14a49e0bcf6e277262918a3))

# 1.3.0 (2020-08-17)

## 1.2.11 (2020-08-03)

## 1.2.10 (2020-07-28)

## 1.2.9 (2020-07-24)

## 1.2.8 (2020-07-21)

## 1.2.7 (2020-07-14)

### Bug Fixes

- **layout:** type typo ([#962](https://github.com/alibaba/formily/issues/962)) ([9b9f052](https://github.com/alibaba/formily/commit/9b9f052f53f38e90ff39d9ad242a8e73c31102b4))

## 1.2.5 (2020-07-09)

## 1.2.4 (2020-07-06)

## 1.2.3 (2020-07-05)

### Features

- **core:** support_disable_unmount_clear_states ([#938](https://github.com/alibaba/formily/issues/938)) ([236c781](https://github.com/alibaba/formily/commit/236c781204e8846b5ce778925a49da5ea51a0b62))
- **layout:** compat antv3 and fix layout related issue ([#949](https://github.com/alibaba/formily/issues/949)) ([503451f](https://github.com/alibaba/formily/commit/503451f976d65f5e2178011b41fdad77241a8d80))

## 1.2.2 (2020-06-30)

# 1.2.0 (2020-06-28)

### Bug Fixes

- **react:** fix ArrayTable index and FormSpy ([#904](https://github.com/alibaba/formily/issues/904)) ([944891f](https://github.com/alibaba/formily/commit/944891f78664a0d0334ac2ef528e32b4e7553f71))

### Features

- **layout:** add inset mode for mega layout ([#900](https://github.com/alibaba/formily/issues/900)) ([6f17331](https://github.com/alibaba/formily/commit/6f173317b8cb2a1f3dc81278f59f52fd9fabc232))
- chore(publish): v1.2.0 ([34f15ce](https://github.com/alibaba/formily/commit/34f15ce59c40da4e444939833cbc225146dacb90))

## 1.1.6 (2020-05-25)

### Bug Fixes

- megalayout columns ([#871](https://github.com/alibaba/formily/issues/871)) ([9bff1f2](https://github.com/alibaba/formily/commit/9bff1f291d3a61a50893dbdfae4e22a0707a095e))

## 1.1.5 (2020-05-19)

### Bug Fixes

- **react:** fix useField/useVirtualField props assign ([#858](https://github.com/alibaba/formily/issues/858)) ([e71e527](https://github.com/alibaba/formily/commit/e71e527a832b3a18c4fcb2f6ae575469aee5b56c))

## 1.1.4 (2020-05-18)

### Bug Fixes

- **react:** fix formSpy conflict with parent SchemaForm ([#854](https://github.com/alibaba/formily/issues/854)) ([e122c9d](https://github.com/alibaba/formily/commit/e122c9d9036dec3829a13ab7222b26c639cae909))
- **react:** fix useFormEffects typings ([#856](https://github.com/alibaba/formily/issues/856)) ([9b35275](https://github.com/alibaba/formily/commit/9b35275e6ce20fe7236bc7732f02d8de3ad9e109))

## 1.1.3 (2020-04-27)

### Features

- **antd/next:** improve useFormTableQuery ([#821](https://github.com/alibaba/formily/issues/821)) ([2de71a3](https://github.com/alibaba/formily/commit/2de71a36951ce66da71d6d9cfd33daed6e1253c0))

## 1.1.2 (2020-04-19)

## 1.1.1 (2020-04-14)

### Bug Fixes

- **project:** fix [#788](https://github.com/alibaba/formily/issues/788) [#789](https://github.com/alibaba/formily/issues/789) [#790](https://github.com/alibaba/formily/issues/790) [#792](https://github.com/alibaba/formily/issues/792) ([#793](https://github.com/alibaba/formily/issues/793)) ([890b64e](https://github.com/alibaba/formily/commit/890b64eb44aada82b9a63fa60f7688d3fa5fb291))

### Features

- **core:** remove initializeLazySyncState ([70094be](https://github.com/alibaba/formily/commit/70094beb7878d51c81bfaf766e85c8d0e1071641))

# 1.1.0 (2020-04-05)

## 1.0.11 (2020-04-04)

### Bug Fixes

- **core:** fix initialValues validate ([#770](https://github.com/alibaba/formily/issues/770)) ([ce2e2fc](https://github.com/alibaba/formily/commit/ce2e2fc8816cc55604e66105a42d9a85832ef0b6))

## 1.0.10 (2020-03-28)

## 1.0.9 (2020-03-22)

### Bug Fixes

- **core:** fix field notify ([ead7284](https://github.com/alibaba/formily/commit/ead7284773e6ae18cf35949c8310180d1f49c010))

### Features

- **core:** support pass FormPathPattern to createMutators, and fix some typings ([#728](https://github.com/alibaba/formily/issues/728)) ([c0798c6](https://github.com/alibaba/formily/commit/c0798c6d2ddd2a9fc7869c01e3fad164393cd829))
- **hooks:** add onSubmit hook and docs ([#727](https://github.com/alibaba/formily/issues/727)) ([b99be56](https://github.com/alibaba/formily/commit/b99be5668a0e823a3d5dccefffdb12629679ebf3))
- add recursive-render doc and fix some bugs ([#736](https://github.com/alibaba/formily/issues/736)) ([d7199d8](https://github.com/alibaba/formily/commit/d7199d82c67d56d9ac8d550fd266a2307597a088))

## 1.0.7 (2020-03-15)

### Features

- **core:** change visible behavior to fix array list delete auto assign value not work ([#725](https://github.com/alibaba/formily/issues/725)) ([366047e](https://github.com/alibaba/formily/commit/366047e68a92339d0060bd52bdf05db61e5fd9e5))

## 1.0.6 (2020-03-14)

### Bug Fixes

- **core:** fix typings ([#718](https://github.com/alibaba/formily/issues/718)) ([6000f71](https://github.com/alibaba/formily/commit/6000f71480d53140e7476b4734b8e52022f1c12e))

### Features

- **shared:** support BigData ([#708](https://github.com/alibaba/formily/issues/708)) ([7343b96](https://github.com/alibaba/formily/commit/7343b96063ab988763e4b265cf47548c40fd3412))

### Performance Improvements

- **core:** fix nested path update performance ([#722](https://github.com/alibaba/formily/issues/722)) ([130feea](https://github.com/alibaba/formily/commit/130feeaeb2107849e378d8fb1b702167d93a7e89))

## 1.0.5 (2020-03-08)

## 1.0.3 (2020-02-29)

### Bug Fixes

- **project:** fix typings ([#669](https://github.com/alibaba/formily/issues/669)) ([bf5a09e](https://github.com/alibaba/formily/commit/bf5a09e08137fcb4b11958fcd73b2744f303c57e))

## 1.0.1 (2020-02-22)

### Bug Fixes

- **@uform/antd/next:** fix components error ([8edf2e9](https://github.com/alibaba/formily/commit/8edf2e9822f8b3a0acdfd15ca95f286fe1739217))
- **@uform/antd/next/react:** doc ([#437](https://github.com/alibaba/formily/issues/437)) ([fd93386](https://github.com/alibaba/formily/commit/fd93386fe5e03fd89a438746d064758933539863))
- **@uform/core:** fix effect errors can not prevent submit ([#595](https://github.com/alibaba/formily/issues/595)) ([11dc893](https://github.com/alibaba/formily/commit/11dc8933c93cc567c497dcf4821419011b818257))
- **@uform/core:** fix sync value ([#460](https://github.com/alibaba/formily/issues/460)) ([9e72dd6](https://github.com/alibaba/formily/commit/9e72dd6f0faae45b875e5598dbcd88c342a563dc))
- **@uform/core:** validate ([#484](https://github.com/alibaba/formily/issues/484)) ([9093ab2](https://github.com/alibaba/formily/commit/9093ab2b22e622d902f23de907c93f8e29952512))
- **@uform/core/react:** fix [#613](https://github.com/alibaba/formily/issues/613) [#615](https://github.com/alibaba/formily/issues/615) ([#618](https://github.com/alibaba/formily/issues/618)) ([8dc609f](https://github.com/alibaba/formily/commit/8dc609f948673f26be4d001462c4ca09a554d3b4))
- **@uform/react:** fix unmount ([#436](https://github.com/alibaba/formily/issues/436)) ([e2aa55e](https://github.com/alibaba/formily/commit/e2aa55ea2759c7939ead006bb8b5ba2c85c264eb))
- issue[#543](https://github.com/alibaba/formily/issues/543) ([#545](https://github.com/alibaba/formily/issues/545)) ([ec9c0df](https://github.com/alibaba/formily/commit/ec9c0dfca2aeb96ab73b1afd6626ad09c281290f))
- **@uform/react-shared-components:** fix text ([#349](https://github.com/alibaba/formily/issues/349)) ([209a4da](https://github.com/alibaba/formily/commit/209a4da200e0d896c7e4a98df90042a84020d38e))
- 616 ([#622](https://github.com/alibaba/formily/issues/622)) ([23ff144](https://github.com/alibaba/formily/commit/23ff1447ccab2f49b59c0b8babaf0e0ceea0f7df))
- **@uform/react/antd/next:** Fix field state errors ([#442](https://github.com/alibaba/formily/issues/442)) ([0872f40](https://github.com/alibaba/formily/commit/0872f40e80b583c037f61b39d52f7c4a07d1f989))
- **@uform/shared:** fix isValid ([#604](https://github.com/alibaba/formily/issues/604)) ([4136691](https://github.com/alibaba/formily/commit/4136691d6a24dbe54b14f6fc8cdb2fa718b931fd))
- **meet:** fix ci ([#660](https://github.com/alibaba/formily/issues/660)) ([0aba448](https://github.com/alibaba/formily/commit/0aba4483b2efd522d1e3fce0205174e0edf957be))
- **project:** fix typings ([#664](https://github.com/alibaba/formily/issues/664)) ([b24aff8](https://github.com/alibaba/formily/commit/b24aff8c652b51e1c3b7f94c37b79204d6f83bdf))
- build on windows ([#539](https://github.com/alibaba/formily/issues/539)) ([8ad9932](https://github.com/alibaba/formily/commit/8ad9932232f787793603273a670cfe532b53eecc))

### Features

- **@uform/core:** reset add clearInitialValue ([#627](https://github.com/alibaba/formily/issues/627)) ([02e715c](https://github.com/alibaba/formily/commit/02e715ce7caea1f36a6a1e44c7c580c025cea1a0))
- **@uform/core:** support pass visible/display of register method ([#421](https://github.com/alibaba/formily/issues/421)) ([908882a](https://github.com/alibaba/formily/commit/908882a2968db2b0fbde4792f6c8ca7dc2725016))
- **@uform/core/react:** add unittest and add lifecycles ([#536](https://github.com/alibaba/formily/issues/536)) ([8550732](https://github.com/alibaba/formily/commit/855073222895079893548619e3381835c9ef8127))
- **@uform/devtools:** first version ([#634](https://github.com/alibaba/formily/issues/634)) ([3483927](https://github.com/alibaba/formily/commit/3483927a85f997dc0819550b7d622b80db71f017))
- **@uform/react:** actions support clearErrors ([#434](https://github.com/alibaba/formily/issues/434)) ([551d74c](https://github.com/alibaba/formily/commit/551d74c11ee51e5b74755ceb30fd0056eed82079))
- **@uform/react:** remove raf and fix unittest ([#422](https://github.com/alibaba/formily/issues/422)) ([670fadb](https://github.com/alibaba/formily/commit/670fadbe75935051b5b3a202423975ef223afe5a))
- **@uform/react:** support filter changed ([#353](https://github.com/alibaba/formily/issues/353)) ([fc516fb](https://github.com/alibaba/formily/commit/fc516fbcec5bf1910d40a2b90774078b7e30bb9e))
- add actions test ([3ec4f09](https://github.com/alibaba/formily/commit/3ec4f098c6e4a193c58889ad1ffd2f67c3ac1a8e))
- add react/actions tests ([21ee40b](https://github.com/alibaba/formily/commit/21ee40b157b53529ff231d13ecdd3b54ee6f8e88))
- support useFormEffects ([#403](https://github.com/alibaba/formily/issues/403)) ([dff959c](https://github.com/alibaba/formily/commit/dff959c87c62c2c63c401b819788fade7c5da847))
- **@uform/react:** support form dev tools hook ([#633](https://github.com/alibaba/formily/issues/633)) ([1bc8328](https://github.com/alibaba/formily/commit/1bc8328d2816179ccaf825281b6f904b1bcc4a8f))
- **@uform/react:** support useFieldState/useFormState ([#433](https://github.com/alibaba/formily/issues/433)) ([9440ac4](https://github.com/alibaba/formily/commit/9440ac4511cf6c964edb5044f68d716798b9582f))
- **@uform/react-schema-renderer:** improve linkage ([3261894](https://github.com/alibaba/formily/commit/3261894ea0e3ad8abd04e594164f8da3ed4df809))
- **project:** rename uform==>formily ([#636](https://github.com/alibaba/formily/issues/636)) ([48c47c2](https://github.com/alibaba/formily/commit/48c47c2946f49bd71559173ad9ceed69546457f8))
- **project:** update formily code and docs ([#651](https://github.com/alibaba/formily/issues/651)) ([2acd958](https://github.com/alibaba/formily/commit/2acd958eeb3ef05bc5ce1784ceb68798c384f00e))
- update unitest and document ([#476](https://github.com/alibaba/formily/issues/476)) ([8c49ca9](https://github.com/alibaba/formily/commit/8c49ca9a4a8d3de7be3ed68bfd48fdddfce4da08))

## 0.4.3 (2019-09-30)

## 0.4.2 (2019-09-23)

## 0.4.1 (2019-09-09)

# 0.4.0 (2019-09-01)

### Bug Fixes

- **@uform/core:** fix async validate prevent submit ([#290](https://github.com/alibaba/formily/issues/290)) ([efdf0bf](https://github.com/alibaba/formily/commit/efdf0bf2f7d71d32f1b31c9c0facacec0c8b1b1f))
- **core:** Increase lastValidateValue value processing during initialization ([#276](https://github.com/alibaba/formily/issues/276)) ([045f6fe](https://github.com/alibaba/formily/commit/045f6fea44588dd0dc6a5c15cba5dca26dcb432e))

## 0.3.11 (2019-08-18)

## 0.3.10 (2019-08-10)

## 0.3.9 (2019-08-06)

## 0.3.9-beta.0 (2019-08-06)

## 0.3.8 (2019-08-06)

### Bug Fixes

- **@uform/core:** fix value can't be remove in onFieldChange subscriber ([#233](https://github.com/alibaba/formily/issues/233)) ([3896efb](https://github.com/alibaba/formily/commit/3896efb6309aa80050bde54198bf2c69fd3df64c))
- **@uform/react:** fix schema properties can not update when rerender ([#220](https://github.com/alibaba/formily/issues/220)) ([4a6f4dc](https://github.com/alibaba/formily/commit/4a6f4dc3dc45ac714ef6a39cf7fd0218730e2b75))
- **@uform/react:** invariant initialValues will not be changed when form rerender ([#214](https://github.com/alibaba/formily/issues/214)) ([b9efa4c](https://github.com/alibaba/formily/commit/b9efa4ca8b74fdf24761264d96aaaaf33482d6a0))
- **@uform/validator:** Fix validate threshold check ([#235](https://github.com/alibaba/formily/issues/235)) ([3ca7c08](https://github.com/alibaba/formily/commit/3ca7c086081384aaa445e111749a1b84d17078ed))

## 0.3.7 (2019-07-30)

## 0.3.6 (2019-07-25)

## 0.3.5 (2019-07-25)

## 0.3.4 (2019-07-25)

### Bug Fixes

- **@uform/core:** fix field props transformer is not work ([8686c7c](https://github.com/alibaba/formily/commit/8686c7c8122700fc62634a68e9189bbeeb5ee0b9))
- **@uform/core:** fix field props transformer is not work ([e149be8](https://github.com/alibaba/formily/commit/e149be8d2c7e85e176ff3b0c29a3ca02dd12c573))
- **@uform/core/react:** Fix intialValues can not one way controlled ([#194](https://github.com/alibaba/formily/issues/194)) ([3c845bc](https://github.com/alibaba/formily/commit/3c845bc1624422b94a3b871e2106bbfa0927588b))

## 0.3.3 (2019-07-23)

### Bug Fixes

- **@uform/core:** fix setFormState is not work( [#189](https://github.com/alibaba/formily/issues/189)) ([66eb0a2](https://github.com/alibaba/formily/commit/66eb0a2d8ffde1ea778daca65d76f50310bc1d18))

## 0.3.2 (2019-07-18)

### Features

- **docs:** support deconstruction ([#179](https://github.com/alibaba/formily/issues/179)) ([b114c9e](https://github.com/alibaba/formily/commit/b114c9e7278c3f980ff1f057021dba589c93dff1))

## 0.3.1 (2019-07-16)

### Bug Fixes

- **typescript:** fix ts build can not transplie jsx ([0dfcba7](https://github.com/alibaba/formily/commit/0dfcba7c4c3e823edbe5718ff6d00cd09693fbc7))
- **typescript:** fix typescript config ([546d9f0](https://github.com/alibaba/formily/commit/546d9f01ba63853b69c52078c214d9c3f76abf98))

### Reverts

- Revert "chore(publish): v0.3.0" ([d02c102](https://github.com/alibaba/formily/commit/d02c102eebba43b2dbbd982f8080adc2b9c3eb96))

# 0.3.0 (2019-07-15)

### Bug Fixes

- **@uform/react:** fix field is not recevie broadcast property ([#173](https://github.com/alibaba/formily/issues/173)) ([a897144](https://github.com/alibaba/formily/commit/a897144750207a248792dc6f7aec781269b89bcc))
- **@uform/react:** Fix form controlled ([#167](https://github.com/alibaba/formily/issues/167)) ([c12ecb9](https://github.com/alibaba/formily/commit/c12ecb912fdebc1e5427394d392dd78ed538e364))

### Features

- **@uform/core:** support display of fieldState ([#166](https://github.com/alibaba/formily/issues/166)) ([e0ae0fb](https://github.com/alibaba/formily/commit/e0ae0fb8a80a7be7c839de1c3b731b99f50c4fe1))
- **@uform/react:** Feat improve broadcast ([#169](https://github.com/alibaba/formily/issues/169)) ([177d6b2](https://github.com/alibaba/formily/commit/177d6b21d75de3b94da0033746c7d88da455b7ab))
- **@uform/react:** support createControllerBox ([#172](https://github.com/alibaba/formily/issues/172)) ([56263a4](https://github.com/alibaba/formily/commit/56263a48bcd23577aad8d2211bae5f4eee3e9bdc))
- **@uform/types:** improve types ([#168](https://github.com/alibaba/formily/issues/168)) ([0e6fd69](https://github.com/alibaba/formily/commit/0e6fd69c8e67ab8be75c0a65b36671ab2ab783ac))
