(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.Formily = global.Formily || {}, global.Formily.React = {})));
}(this, (function (exports) { 'use strict';

    var __read$3 = (undefined && undefined.__read) || function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };
    var __spread$2 = (undefined && undefined.__spread) || function () {
        for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read$3(arguments[i]));
        return ar;
    };
    var ExpRE = /^\s*\{\{([\s\S]*)\}\}\s*$/;
    var actionsSymbol = Symbol.for('__REVA_ACTIONS');
    var ENVS = {
        silent: false,
        compile: function (expression, scope) {
            var vars = Object.keys(scope || {});
            var params = vars.map(function (key) { return scope[key]; });
            if (ENVS.silent) {
                try {
                    return new (Function.bind.apply(Function, __spread$2([void 0], vars, ["return (" + expression + ");"])))().apply(void 0, __spread$2(params));
                }
                catch (_a) { }
            }
            else {
                return new (Function.bind.apply(Function, __spread$2([void 0], vars, ["return (" + expression + ");"])))().apply(void 0, __spread$2(params));
            }
        },
    };
    var silent = function (value) {
        if (value === void 0) { value = true; }
        ENVS.silent = !!value;
    };
    var registerCompiler = function (compiler) {
        if (Formily.Shared.isFn(compiler)) {
            ENVS.compile = compiler;
        }
    };
    var shallowCompile = function (source, scope) {
        if (Formily.Shared.isStr(source)) {
            var matched = source.match(ExpRE);
            if (!matched)
                return source;
            return ENVS.compile(matched[1], scope);
        }
        else if (Formily.Shared.isArr(source)) {
            return source.map(function (item) { return shallowCompile(item, scope); });
        }
        return source;
    };
    var compile = function (source, scope) {
        var seenObjects = new WeakMap();
        var compile = function (source) {
            if (Formily.Shared.isStr(source)) {
                return shallowCompile(source, scope);
            }
            else if (Formily.Shared.isArr(source)) {
                return source.map(function (value) { return compile(value); });
            }
            else if (Formily.Shared.isPlainObj(source)) {
                if ('$$typeof' in source && '_owner' in source) {
                    return source;
                }
                if (source[actionsSymbol]) {
                    return source;
                }
                if (source['_isAMomentObject']) {
                    return source;
                }
                if (Schema.isSchemaInstance(source)) {
                    return source.compile(scope);
                }
                if (Formily.Shared.isFn(source['toJS'])) {
                    return source;
                }
                if (Formily.Shared.isFn(source['toJSON'])) {
                    return source;
                }
                if (Formily.Reactive.isObservable(source)) {
                    return source;
                }
                if (seenObjects.get(source)) {
                    return source;
                }
                seenObjects.set(source, true);
                var results = Formily.Shared.reduce(source, function (buf, value, key) {
                    buf[key] = compile(value);
                    return buf;
                }, {});
                seenObjects.set(source, false);
                return results;
            }
            return source;
        };
        return compile(source);
    };

    var __assign$3 = (undefined && undefined.__assign) || function () {
        __assign$3 = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign$3.apply(this, arguments);
    };
    var __read$2 = (undefined && undefined.__read) || function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };

    var FieldEffects = {
        onFieldInit: Formily.Core.onFieldInit,
        onFieldMount: Formily.Core.onFieldMount,
        onFieldUnmount: Formily.Core.onFieldUnmount,
        onFieldValueChange: Formily.Core.onFieldValueChange,
        onFieldInputValueChange: Formily.Core.onFieldInputValueChange,
        onFieldInitialValueChange: Formily.Core.onFieldInitialValueChange,
        onFieldValidateStart: Formily.Core.onFieldValidateStart,
        onFieldValidateEnd: Formily.Core.onFieldValidateEnd,
        onFieldValidateFailed: Formily.Core.onFieldValidateFailed,
        onFieldValidateSuccess: Formily.Core.onFieldValidateSuccess,
    };
    var getValidator = function (schema) {
        var rules = [];
        if (schema.format) {
            rules.push({ format: schema.format });
        }
        if (Formily.Shared.isValid(schema.maxItems)) {
            rules.push({ max: schema.maxItems });
        }
        if (Formily.Shared.isValid(schema.minItems)) {
            rules.push({ min: schema.minItems });
        }
        if (Formily.Shared.isValid(schema.maxLength)) {
            rules.push({ max: schema.maxLength });
        }
        if (Formily.Shared.isValid(schema.minLength)) {
            rules.push({ min: schema.minLength });
        }
        if (Formily.Shared.isValid(schema.maximum)) {
            rules.push({ maximum: schema.maximum });
        }
        if (Formily.Shared.isValid(schema.minimum)) {
            rules.push({ minimum: schema.minimum });
        }
        if (Formily.Shared.isValid(schema.exclusiveMaximum)) {
            rules.push({ exclusiveMaximum: schema.exclusiveMaximum });
        }
        if (Formily.Shared.isValid(schema.exclusiveMinimum)) {
            rules.push({ exclusiveMinimum: schema.exclusiveMinimum });
        }
        if (Formily.Shared.isValid(schema.pattern)) {
            rules.push({ pattern: schema.pattern });
        }
        if (Formily.Shared.isValid(schema.const)) {
            rules.push({
                validator: function (value, rule, ctx, format) {
                    if (Formily.Shared.isEmpty(value))
                        return '';
                    return value === schema.const
                        ? ''
                        : format(Formily.Validator.getValidateLocale('schema.const'), schema);
                },
            });
        }
        if (Formily.Shared.isValid(schema.multipleOf)) {
            rules.push({
                validator: function (value, rule, ctx, format) {
                    if (Formily.Shared.isEmpty(value))
                        return '';
                    return value % schema.multipleOf === 0
                        ? ''
                        : format(Formily.Validator.getValidateLocale('schema.multipleOf'), schema);
                },
            });
        }
        if (Formily.Shared.isValid(schema.maxProperties)) {
            rules.push({
                validator: function (value, rule, ctx, format) {
                    if (Formily.Shared.isEmpty(value))
                        return '';
                    return Object.keys(value || {}).length <= schema.maxProperties
                        ? ''
                        : format(Formily.Validator.getValidateLocale('schema.maxProperties'), schema);
                },
            });
        }
        if (Formily.Shared.isValid(schema.minProperties)) {
            rules.push({
                validator: function (value, rule, ctx, format) {
                    if (Formily.Shared.isEmpty(value))
                        return '';
                    return Object.keys(value || {}).length >= schema.minProperties
                        ? ''
                        : format(Formily.Validator.getValidateLocale('schema.minProperties'), schema);
                },
            });
        }
        if (Formily.Shared.isValid(schema.uniqueItems)) {
            rules.push({
                validator: function (value, rule, ctx, format) {
                    value = Formily.Shared.toArr(value);
                    return value.some(function (item, index) {
                        for (var start = index; start < value.length; start++) {
                            if (Formily.Shared.isEqual(value[start], item)) {
                                return false;
                            }
                        }
                    })
                        ? format(Formily.Validator.getValidateLocale('schema.uniqueItems'), schema)
                        : '';
                },
            });
        }
        if (Formily.Shared.isValid(schema['x-validator'])) {
            rules = rules.concat(schema['x-validator']);
        }
        if (rules.length)
            return rules;
    };
    var getDataSource = function (schema) {
        if (Formily.Shared.isArr(schema['enum'])) {
            return schema['enum'].map(function (item) {
                if (typeof item === 'object') {
                    return item;
                }
                else {
                    return {
                        label: item,
                        value: item,
                    };
                }
            });
        }
    };
    var findComponent = function (type, path, options, state) {
        var _a, _b;
        if (path) {
            var component = Formily.Shared.FormPath.getIn(options === null || options === void 0 ? void 0 : options.components, path) || ((_a = state === null || state === void 0 ? void 0 : state[type]) === null || _a === void 0 ? void 0 : _a[0]);
            if (component) {
                return component;
            }
            if (options === null || options === void 0 ? void 0 : options.components) {
                console.error("[Formily JSON Schema]: Cannot find the '" + path + "' component mapped by Schema.x-" + type);
            }
        }
        return (_b = state === null || state === void 0 ? void 0 : state[type]) === null || _b === void 0 ? void 0 : _b[0];
    };
    var getBaseProps = function (schema, options, state) {
        var _a, _b;
        var props = {};
        var validator = getValidator(schema);
        var dataSource = getDataSource(schema);
        var editable = Formily.Shared.isValid(schema['x-editable'])
            ? schema['x-editable']
            : schema['writeOnly'];
        var readOnly = Formily.Shared.isValid(schema['x-read-only'])
            ? schema['x-read-only']
            : schema['readOnly'];
        var decoratorType = findComponent('decorator', schema['x-decorator'], options, state);
        var decoratorProps = schema['x-decorator-props'] || ((_a = state === null || state === void 0 ? void 0 : state.decorator) === null || _a === void 0 ? void 0 : _a[1]);
        var componentType = findComponent('component', schema['x-component'], options, state);
        var componentProps = schema['x-component-props'] || ((_b = state === null || state === void 0 ? void 0 : state.component) === null || _b === void 0 ? void 0 : _b[1]);
        if (Formily.Shared.isValid(schema.default)) {
            props.initialValue = schema.default;
        }
        if (Formily.Shared.isValid(schema.title)) {
            props.title = schema.title;
        }
        if (Formily.Shared.isValid(schema.description)) {
            props.description = schema.description;
        }
        if (Formily.Shared.isValid(schema['x-disabled'])) {
            props.disabled = schema['x-disabled'];
        }
        if (Formily.Shared.isValid(schema['x-read-pretty'])) {
            props.readPretty = schema['x-read-pretty'];
        }
        if (Formily.Shared.isValid(schema['x-visible'])) {
            props.visible = schema['x-visible'];
        }
        if (Formily.Shared.isValid(schema['x-hidden'])) {
            props.hidden = schema['x-hidden'];
        }
        if (Formily.Shared.isValid(schema['x-display'])) {
            props.display = schema['x-display'];
        }
        if (Formily.Shared.isValid(schema['x-pattern'])) {
            props.pattern = schema['x-pattern'];
        }
        if (Formily.Shared.isValid(validator)) {
            props.validator = validator;
        }
        if (Formily.Shared.isValid(dataSource)) {
            props.dataSource = dataSource;
        }
        if (!Formily.Shared.isValid(editable)) {
            props.editable = editable;
        }
        if (Formily.Shared.isValid(readOnly)) {
            props.readOnly = readOnly;
        }
        if (Formily.Shared.isValid(decoratorType)) {
            props.decorator = [decoratorType, decoratorProps];
        }
        if (Formily.Shared.isValid(componentType)) {
            props.component = [componentType, componentProps];
        }
        return props;
    };
    var patchState = function (state, target) {
        var patch = function (target, path) {
            if (Formily.Shared.isPlainObj(target)) {
                Formily.Shared.each(target, function (value, key) {
                    patch(value, path.concat(key));
                });
            }
            else {
                Formily.Shared.FormPath.setIn(state, path, target);
            }
        };
        Formily.Reactive.untracked(function () {
            patch(target, []);
        });
        return state;
    };
    var getRequired = function (schema) {
        if (Formily.Shared.isBool(schema.required)) {
            return schema.required;
        }
        var parent = schema.parent;
        while (parent) {
            if (Formily.Shared.isStr(parent.required)) {
                if (Formily.Shared.FormPath.parse(parent.required).match(schema.name))
                    return true;
            }
            else if (Formily.Shared.isArr(parent.required)) {
                if (parent.required.some(function (parent) {
                    return Formily.Shared.FormPath.parse(parent).match(schema.name);
                })) {
                    return true;
                }
            }
            parent = parent.parent;
        }
        return undefined;
    };
    var getReactions = function (schema, options) {
        var setSchemaFieldState = function (field, request, compile) {
            if (!request)
                return;
            if (request.state) {
                field.setState(function (state) { return patchState(state, compile(request.state)); });
            }
            if (request.schema) {
                field.setState(function (state) {
                    return patchState(state, getBaseProps(patchState({}, compile(request.schema)), options, state));
                });
            }
        };
        var setSchemaFieldStateByTarget = function (form, target, request, compile) {
            if (!request)
                return;
            if (request.state) {
                form.setFieldState(target, function (state) {
                    return patchState(state, compile(request.state, state));
                });
            }
            if (request.schema) {
                form.setFieldState(target, function (state) {
                    return patchState(state, getBaseProps(patchState({}, compile(request.schema, state)), options, state));
                });
            }
        };
        var queryDepdency = function (field, pattern) {
            var _a = __read$2(String(pattern).split(/\s*#\s*/), 2), target = _a[0], path = _a[1];
            return field.query(target).getIn(path || 'value');
        };
        var parseDependencies = function (field, dependencies) {
            if (Formily.Shared.isArr(dependencies)) {
                return dependencies.map(function (pattern) { return queryDepdency(field, pattern); });
            }
            else if (Formily.Shared.isPlainObj(dependencies)) {
                return Formily.Shared.reduce(dependencies, function (buf, pattern, key) {
                    buf[key] = queryDepdency(field, pattern);
                    return buf;
                }, {});
            }
            return [];
        };
        return function (field) {
            var reactions = Formily.Shared.toArr(schema['x-reactions']);
            reactions.forEach(function (reaction) {
                var _a;
                if (!reaction)
                    return;
                if (Formily.Shared.isFn(reaction)) {
                    return reaction(field);
                }
                var run = function () {
                    var _a, _b, _c, _d;
                    var $self = field;
                    var $form = field.form;
                    var $deps = parseDependencies(field, reaction.dependencies);
                    var $dependencies = $deps;
                    var scope = __assign$3(__assign$3({}, options.scope), { $target: null, $form: $form,
                        $self: $self,
                        $deps: $deps,
                        $dependencies: $dependencies });
                    var compile = function (expression, target) {
                        if (target) {
                            scope.$target = target;
                        }
                        return Schema.compile(expression, scope);
                    };
                    var when = Schema.compile(reaction === null || reaction === void 0 ? void 0 : reaction.when, scope);
                    var condition = Formily.Shared.isValid(reaction === null || reaction === void 0 ? void 0 : reaction.when) ? when : true;
                    if (condition) {
                        if (reaction.target) {
                            setSchemaFieldStateByTarget(field.form, reaction.target, reaction.fulfill, compile);
                        }
                        else {
                            setSchemaFieldState(field, reaction.fulfill, compile);
                        }
                        if (Formily.Shared.isStr((_a = reaction.fulfill) === null || _a === void 0 ? void 0 : _a.run)) {
                            compile("{{async function(){" + ((_b = reaction.fulfill) === null || _b === void 0 ? void 0 : _b.run) + "}}}")();
                        }
                    }
                    else {
                        if (reaction.target) {
                            setSchemaFieldStateByTarget(field.form, reaction.target, reaction.otherwise, compile);
                        }
                        else {
                            setSchemaFieldState(field, reaction.otherwise, compile);
                        }
                        if (Formily.Shared.isStr((_c = reaction.otherwise) === null || _c === void 0 ? void 0 : _c.run)) {
                            compile("{{async function(){" + ((_d = reaction.otherwise) === null || _d === void 0 ? void 0 : _d.run) + "}}}")();
                        }
                    }
                };
                if (reaction.target) {
                    reaction.effects = ((_a = reaction.effects) === null || _a === void 0 ? void 0 : _a.length) ? reaction.effects
                        : ['onFieldInit', 'onFieldValueChange'];
                }
                if (reaction.effects) {
                    Formily.Shared.each(reaction.effects, function (type) {
                        if (FieldEffects[type]) {
                            Formily.Reactive.untracked(function () {
                                FieldEffects[type](field.address, run);
                            });
                        }
                    });
                }
                else {
                    run();
                }
            });
        };
    };
    var transformSchemaToFieldProps = function (schema, options) {
        var required = getRequired(schema);
        var reactions = getReactions(schema, options);
        var props = getBaseProps(schema, options);
        props.required = required;
        props.name = schema.name;
        props.reactions = [reactions];
        return props;
    };

    var __assign$2 = (undefined && undefined.__assign) || function () {
        __assign$2 = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign$2.apply(this, arguments);
    };

    var patches = [];
    var polyfills = {};
    var reducePatches = function (schema) {
        return patches.reduce(function (buf, patch) {
            return patch(buf);
        }, __assign$2({}, schema));
    };
    var registerPatches = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        args.forEach(function (patch) {
            if (Formily.Shared.isFn(patch)) {
                patches.push(patch);
            }
        });
    };
    var registerPolyfills = function (version, patch) {
        if (version && Formily.Shared.isFn(patch)) {
            polyfills[version] = polyfills[version] || [];
            polyfills[version].push(patch);
        }
    };
    var enablePolyfills = function (versions) {
        if (Formily.Shared.isArr(versions)) {
            versions.forEach(function (version) {
                if (Formily.Shared.isArr(polyfills[version])) {
                    polyfills[version].forEach(function (patch) {
                        registerPatches(patch);
                    });
                }
            });
        }
    };

    var __assign$1 = (undefined && undefined.__assign) || function () {
        __assign$1 = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign$1.apply(this, arguments);
    };
    var __read$1 = (undefined && undefined.__read) || function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };
    var __spread$1 = (undefined && undefined.__spread) || function () {
        for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read$1(arguments[i]));
        return ar;
    };

    var VOID_COMPONENTS = [
        'card',
        'block',
        'grid-col',
        'grid-row',
        'grid',
        'layout',
        'step',
        'tab',
        'text-box',
    ];
    var TYPE_DEFAULT_COMPONENTS = {};
    var transformCondition = function (condition) {
        if (Formily.Shared.isStr(condition)) {
            return condition.replace(/\$value/, '$self.value');
        }
    };
    var transformXLinkage = function (linkages) {
        if (Formily.Shared.isArr(linkages)) {
            return linkages.reduce(function (buf, item) {
                if (!item)
                    return buf;
                if (item.type === 'value:visible') {
                    return buf.concat({
                        target: item.target,
                        when: transformCondition(item.condition),
                        fulfill: {
                            state: {
                                visible: true,
                            },
                        },
                        otherwise: {
                            state: {
                                visible: false,
                            },
                        },
                    });
                }
                else if (item.type === 'value:schema') {
                    return buf.concat({
                        target: item.target,
                        when: transformCondition(item.condition),
                        fulfill: {
                            schema: SpecificationV1Polyfill(__assign$1({ version: '1.0' }, item.schema)),
                        },
                        otherwise: {
                            schema: SpecificationV1Polyfill(__assign$1({ version: '1.0' }, item.otherwise)),
                        },
                    });
                }
                else if (item.type === 'value:state') {
                    return buf.concat({
                        target: item.target,
                        when: transformCondition(item.condition),
                        fulfill: {
                            state: item.state,
                        },
                        otherwise: {
                            state: item.otherwise,
                        },
                    });
                }
            }, []);
        }
        return [];
    };
    var SpecificationV1Polyfill = function (schema) {
        if (Formily.Shared.isValid(schema['editable'])) {
            schema['x-editable'] = schema['x-editable'] || schema['editable'];
            delete schema['editable'];
        }
        if (Formily.Shared.isValid(schema['visible'])) {
            schema['x-visible'] = schema['x-visible'] || schema['visible'];
            delete schema['visible'];
        }
        if (Formily.Shared.isValid(schema['display'])) {
            schema['x-display'] =
                schema['x-display'] || (schema['display'] ? 'visible' : 'hidden');
            delete schema['display'];
        }
        if (Formily.Shared.isValid(schema['x-props'])) {
            schema['x-decorator-props'] =
                schema['x-decorator-props'] || schema['x-props'];
            delete schema['display'];
        }
        if (schema['x-linkages']) {
            schema['x-reactions'] = Formily.Shared.toArr(schema['x-reactions']).concat(transformXLinkage(schema['x-linkages']));
            delete schema['x-linkages'];
        }
        if (schema['x-component']) {
            if (VOID_COMPONENTS.some(function (component) { return Formily.Shared.lowerCase(component) === Formily.Shared.lowerCase(schema['x-component']); })) {
                schema['type'] = 'void';
            }
        }
        else {
            if (TYPE_DEFAULT_COMPONENTS[schema['type']]) {
                schema['x-component'] = TYPE_DEFAULT_COMPONENTS[schema['type']];
            }
        }
        if (!schema['x-decorator'] &&
            schema['type'] !== 'void' &&
            schema['type'] !== 'object') {
            schema['x-decorator'] = schema['x-decorator'] || 'FormItem';
        }
        if (schema['x-rules']) {
            schema['x-validator'] = []
                .concat(schema['x-validator'] || [])
                .concat(schema['x-rules']);
        }
        return schema;
    };
    registerPolyfills('1.0', SpecificationV1Polyfill);
    var registerVoidComponents = function (components) {
        VOID_COMPONENTS.push.apply(VOID_COMPONENTS, __spread$1(components));
    };
    var registerTypeDefaultComponents = function (maps) {
        Object.assign(TYPE_DEFAULT_COMPONENTS, maps);
    };

    var ShallowCompileKeys = [
        'properties',
        'patternProperties',
        'additionalProperties',
        'items',
        'additionalItems',
        'x-linkages',
        'x-reactions',
    ];
    var Schema = (function () {
        function Schema(json, parent) {
            var _this = this;
            this._isJSONSchemaObject = true;
            this.version = '2.0';
            this.addProperty = function (key, schema) {
                _this.properties = _this.properties || {};
                _this.properties[key] = new Schema(schema, _this);
                _this.properties[key].name = key;
                return _this.properties[key];
            };
            this.removeProperty = function (key) {
                var schema = _this.properties[key];
                delete _this.properties[key];
                return schema;
            };
            this.setProperties = function (properties) {
                for (var key in properties) {
                    _this.addProperty(key, properties[key]);
                }
                return _this;
            };
            this.addPatternProperty = function (key, schema) {
                if (!schema)
                    return;
                _this.patternProperties = _this.patternProperties || {};
                _this.patternProperties[key] = new Schema(schema, _this);
                _this.patternProperties[key].name = key;
                return _this.patternProperties[key];
            };
            this.removePatternProperty = function (key) {
                var schema = _this.patternProperties[key];
                delete _this.patternProperties[key];
                return schema;
            };
            this.setPatternProperties = function (properties) {
                if (!properties)
                    return _this;
                for (var key in properties) {
                    _this.addPatternProperty(key, properties[key]);
                }
                return _this;
            };
            this.setAdditionalProperties = function (properties) {
                if (!properties)
                    return;
                _this.additionalProperties = new Schema(properties);
                return _this.additionalProperties;
            };
            this.setItems = function (schema) {
                if (!schema)
                    return;
                if (Array.isArray(schema)) {
                    _this.items = schema.map(function (item) { return new Schema(item, _this); });
                }
                else {
                    _this.items = new Schema(schema, _this);
                }
                return _this.items;
            };
            this.setAdditionalItems = function (items) {
                if (!items)
                    return;
                _this.additionalItems = new Schema(items, _this);
                return _this.additionalItems;
            };
            this.findDefinitions = function (ref) {
                if (!ref || !_this.root || !Formily.Shared.isStr(ref))
                    return;
                if (ref.indexOf('#/') !== 0)
                    return;
                return Formily.Shared.FormPath.getIn(_this.root, ref.substring(2).split('/'));
            };
            this.mapProperties = function (callback) {
                return Schema.getOrderProperties(_this).map(function (_a, index) {
                    var schema = _a.schema, key = _a.key;
                    return callback(schema, key, index);
                });
            };
            this.mapPatternProperties = function (callback) {
                return Schema.getOrderProperties(_this, 'patternProperties').map(function (_a, index) {
                    var schema = _a.schema, key = _a.key;
                    return callback(schema, key, index);
                });
            };
            this.reduceProperties = function (callback, predicate) {
                var results = predicate;
                Schema.getOrderProperties(_this, 'properties').forEach(function (_a, index) {
                    var schema = _a.schema, key = _a.key;
                    results = callback(results, schema, key, index);
                });
                return results;
            };
            this.reducePatternProperties = function (callback, predicate) {
                var results = predicate;
                Schema.getOrderProperties(_this, 'patternProperties').forEach(function (_a, index) {
                    var schema = _a.schema, key = _a.key;
                    results = callback(results, schema, key, index);
                });
                return results;
            };
            this.compile = function (scope) {
                var schema = new Schema({}, _this.parent);
                Formily.Shared.each(_this, function (value, key) {
                    if (Formily.Shared.isFn(value) && !key.includes('x-'))
                        return;
                    if (key === 'parent' || key === 'root')
                        return;
                    if (!ShallowCompileKeys.includes(key)) {
                        schema[key] = value ? compile(value, scope) : value;
                    }
                    else {
                        schema[key] = value ? shallowCompile(value, scope) : value;
                    }
                });
                return schema;
            };
            this.fromJSON = function (json) {
                if (!json)
                    return _this;
                if (Schema.isSchemaInstance(json))
                    return json;
                Formily.Shared.each(reducePatches(json), function (value, key) {
                    if (Formily.Shared.isFn(value) && !key.includes('x-'))
                        return;
                    if (key === 'properties') {
                        _this.setProperties(value);
                    }
                    else if (key === 'patternProperties') {
                        _this.setPatternProperties(value);
                    }
                    else if (key === 'additionalProperties') {
                        _this.setAdditionalProperties(value);
                    }
                    else if (key === 'items') {
                        _this.setItems(value);
                    }
                    else if (key === 'additionalItems') {
                        _this.setAdditionalItems(value);
                    }
                    else if (key === '$ref') {
                        _this.fromJSON(_this.findDefinitions(value));
                    }
                    else {
                        _this[key] = value;
                    }
                });
                return _this;
            };
            this.toJSON = function () {
                var results = {};
                Formily.Shared.each(_this, function (value, key) {
                    var _a, _b;
                    if (Formily.Shared.isFn(value) || key === 'parent' || key === 'root')
                        return;
                    if (key === 'properties' || key === 'patternProperties') {
                        results[key] = Formily.Shared.map(value, function (item) { var _a; return (_a = item === null || item === void 0 ? void 0 : item.toJSON) === null || _a === void 0 ? void 0 : _a.call(item); });
                    }
                    else if (key === 'additionalProperties' || key === 'additionalItems') {
                        results[key] = (_a = value === null || value === void 0 ? void 0 : value.toJSON) === null || _a === void 0 ? void 0 : _a.call(value);
                    }
                    else if (key === 'items') {
                        if (Array.isArray(value)) {
                            results[key] = value.map(function (item) { var _a; return (_a = item === null || item === void 0 ? void 0 : item.toJSON) === null || _a === void 0 ? void 0 : _a.call(item); });
                        }
                        else {
                            results[key] = (_b = value === null || value === void 0 ? void 0 : value.toJSON) === null || _b === void 0 ? void 0 : _b.call(value);
                        }
                    }
                    else {
                        results[key] = value;
                    }
                });
                return results;
            };
            this.toFieldProps = function (options) {
                return transformSchemaToFieldProps(_this, options);
            };
            if (parent) {
                this.parent = parent;
                this.root = parent.root;
            }
            else {
                this.root = this;
            }
            return this.fromJSON(json);
        }
        Schema.getOrderProperties = function (schema, propertiesName) {
            if (schema === void 0) { schema = {}; }
            if (propertiesName === void 0) { propertiesName = 'properties'; }
            var orderProperties = [];
            var unorderProperties = [];
            for (var key in schema[propertiesName]) {
                var item = schema[propertiesName][key];
                var index = item['x-index'];
                if (!isNaN(index)) {
                    orderProperties[index] = { schema: item, key: key };
                }
                else {
                    unorderProperties.push({ schema: item, key: key });
                }
            }
            return orderProperties.concat(unorderProperties).filter(function (item) { return !!item; });
        };
        Schema.compile = function (expression, scope) {
            return compile(expression, scope);
        };
        Schema.shallowCompile = function (expression, scope) {
            return shallowCompile(expression, scope);
        };
        Schema.isSchemaInstance = function (value) {
            return Formily.Shared.instOf(value, Schema);
        };
        Schema.registerCompiler = registerCompiler;
        Schema.registerPatches = registerPatches;
        Schema.registerVoidComponents = registerVoidComponents;
        Schema.registerTypeDefaultComponents = registerTypeDefaultComponents;
        Schema.registerPolyfills = registerPolyfills;
        Schema.enablePolyfills = enablePolyfills;
        Schema.silent = silent;
        return Schema;
    }());

    var useAttach = function (target) {
        var oldTargetRef = React.useRef(null);
        React.useEffect(function () {
            if (oldTargetRef.current && target !== oldTargetRef.current) {
                oldTargetRef.current.onUnmount();
            }
            oldTargetRef.current = target;
            target.onMount();
            return function () {
                target.onUnmount();
            };
        }, [target]);
        return target;
    };

    var createContextCleaner = function () {
        var contexts = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            contexts[_i] = arguments[_i];
        }
        return function (_a) {
            var children = _a.children;
            return contexts.reduce(function (buf, ctx) {
                return React.createElement(ctx.Provider, { value: undefined }, buf);
            }, children);
        };
    };
    var FormContext = React.createContext(null);
    var FieldContext = React.createContext(null);
    var SchemaMarkupContext = React.createContext(null);
    var SchemaContext = React.createContext(null);
    var SchemaExpressionScopeContext = React.createContext(null);
    var SchemaOptionsContext = React.createContext(null);
    var ContextCleaner = createContextCleaner(FieldContext, SchemaMarkupContext, SchemaContext, SchemaExpressionScopeContext, SchemaOptionsContext);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    var useForm = function () {
        var form = React.useContext(FormContext);
        if (!form) {
            throw new Error('Can not found form instance from context.');
        }
        return form;
    };

    var useField = function () {
        return React.useContext(FieldContext);
    };

    var useFieldSchema = function () {
        return React.useContext(SchemaContext);
    };

    var useFormEffects = function (effects) {
        var form = useForm();
        var ref = React.useMemo(function () {
            var id = Formily.Shared.uid();
            form.addEffects(id, effects);
            var request = setTimeout(function () {
                form.removeEffects(id);
            }, 100);
            return { id: id, request: request };
        }, []);
        React.useLayoutEffect(function () {
            clearTimeout(ref.request);
            return function () {
                form.removeEffects(ref.id);
            };
        }, []);
    };

    function createCommonjsModule(fn) {
      var module = { exports: {} };
    	return fn(module, module.exports), module.exports;
    }

    /** @license React v16.13.1
     * react-is.production.min.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */
    var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
    Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
    function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}var AsyncMode=l;var ConcurrentMode=m;var ContextConsumer=k;var ContextProvider=h;var Element=c;var ForwardRef=n;var Fragment=e;var Lazy=t;var Memo=r;var Portal=d;
    var Profiler=g;var StrictMode=f;var Suspense=p;var isAsyncMode=function(a){return A(a)||z(a)===l};var isConcurrentMode=A;var isContextConsumer=function(a){return z(a)===k};var isContextProvider=function(a){return z(a)===h};var isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};var isForwardRef=function(a){return z(a)===n};var isFragment=function(a){return z(a)===e};var isLazy=function(a){return z(a)===t};
    var isMemo=function(a){return z(a)===r};var isPortal=function(a){return z(a)===d};var isProfiler=function(a){return z(a)===g};var isStrictMode=function(a){return z(a)===f};var isSuspense=function(a){return z(a)===p};
    var isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};var typeOf=z;

    var reactIs_production_min = {
    	AsyncMode: AsyncMode,
    	ConcurrentMode: ConcurrentMode,
    	ContextConsumer: ContextConsumer,
    	ContextProvider: ContextProvider,
    	Element: Element,
    	ForwardRef: ForwardRef,
    	Fragment: Fragment,
    	Lazy: Lazy,
    	Memo: Memo,
    	Portal: Portal,
    	Profiler: Profiler,
    	StrictMode: StrictMode,
    	Suspense: Suspense,
    	isAsyncMode: isAsyncMode,
    	isConcurrentMode: isConcurrentMode,
    	isContextConsumer: isContextConsumer,
    	isContextProvider: isContextProvider,
    	isElement: isElement,
    	isForwardRef: isForwardRef,
    	isFragment: isFragment,
    	isLazy: isLazy,
    	isMemo: isMemo,
    	isPortal: isPortal,
    	isProfiler: isProfiler,
    	isStrictMode: isStrictMode,
    	isSuspense: isSuspense,
    	isValidElementType: isValidElementType,
    	typeOf: typeOf
    };

    /** @license React v16.13.1
     * react-is.development.js
     *
     * Copyright (c) Facebook, Inc. and its affiliates.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */

    var reactIs_development = createCommonjsModule(function (module, exports) {



    if (process.env.NODE_ENV !== "production") {
      (function() {

    // The Symbol used to tag the ReactElement-like types. If there is no native Symbol
    // nor polyfill, then a plain number is used for performance.
    var hasSymbol = typeof Symbol === 'function' && Symbol.for;
    var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
    var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
    var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
    var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
    var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
    var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
    var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
    // (unstable) APIs that have been removed. Can we remove the symbols?

    var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
    var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
    var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
    var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
    var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
    var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
    var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
    var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
    var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
    var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
    var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

    function isValidElementType(type) {
      return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
      type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
    }

    function typeOf(object) {
      if (typeof object === 'object' && object !== null) {
        var $$typeof = object.$$typeof;

        switch ($$typeof) {
          case REACT_ELEMENT_TYPE:
            var type = object.type;

            switch (type) {
              case REACT_ASYNC_MODE_TYPE:
              case REACT_CONCURRENT_MODE_TYPE:
              case REACT_FRAGMENT_TYPE:
              case REACT_PROFILER_TYPE:
              case REACT_STRICT_MODE_TYPE:
              case REACT_SUSPENSE_TYPE:
                return type;

              default:
                var $$typeofType = type && type.$$typeof;

                switch ($$typeofType) {
                  case REACT_CONTEXT_TYPE:
                  case REACT_FORWARD_REF_TYPE:
                  case REACT_LAZY_TYPE:
                  case REACT_MEMO_TYPE:
                  case REACT_PROVIDER_TYPE:
                    return $$typeofType;

                  default:
                    return $$typeof;
                }

            }

          case REACT_PORTAL_TYPE:
            return $$typeof;
        }
      }

      return undefined;
    } // AsyncMode is deprecated along with isAsyncMode

    var AsyncMode = REACT_ASYNC_MODE_TYPE;
    var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
    var ContextConsumer = REACT_CONTEXT_TYPE;
    var ContextProvider = REACT_PROVIDER_TYPE;
    var Element = REACT_ELEMENT_TYPE;
    var ForwardRef = REACT_FORWARD_REF_TYPE;
    var Fragment = REACT_FRAGMENT_TYPE;
    var Lazy = REACT_LAZY_TYPE;
    var Memo = REACT_MEMO_TYPE;
    var Portal = REACT_PORTAL_TYPE;
    var Profiler = REACT_PROFILER_TYPE;
    var StrictMode = REACT_STRICT_MODE_TYPE;
    var Suspense = REACT_SUSPENSE_TYPE;
    var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

    function isAsyncMode(object) {
      {
        if (!hasWarnedAboutDeprecatedIsAsyncMode) {
          hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

          console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
        }
      }

      return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
    }
    function isConcurrentMode(object) {
      return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
    }
    function isContextConsumer(object) {
      return typeOf(object) === REACT_CONTEXT_TYPE;
    }
    function isContextProvider(object) {
      return typeOf(object) === REACT_PROVIDER_TYPE;
    }
    function isElement(object) {
      return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
    }
    function isForwardRef(object) {
      return typeOf(object) === REACT_FORWARD_REF_TYPE;
    }
    function isFragment(object) {
      return typeOf(object) === REACT_FRAGMENT_TYPE;
    }
    function isLazy(object) {
      return typeOf(object) === REACT_LAZY_TYPE;
    }
    function isMemo(object) {
      return typeOf(object) === REACT_MEMO_TYPE;
    }
    function isPortal(object) {
      return typeOf(object) === REACT_PORTAL_TYPE;
    }
    function isProfiler(object) {
      return typeOf(object) === REACT_PROFILER_TYPE;
    }
    function isStrictMode(object) {
      return typeOf(object) === REACT_STRICT_MODE_TYPE;
    }
    function isSuspense(object) {
      return typeOf(object) === REACT_SUSPENSE_TYPE;
    }

    exports.AsyncMode = AsyncMode;
    exports.ConcurrentMode = ConcurrentMode;
    exports.ContextConsumer = ContextConsumer;
    exports.ContextProvider = ContextProvider;
    exports.Element = Element;
    exports.ForwardRef = ForwardRef;
    exports.Fragment = Fragment;
    exports.Lazy = Lazy;
    exports.Memo = Memo;
    exports.Portal = Portal;
    exports.Profiler = Profiler;
    exports.StrictMode = StrictMode;
    exports.Suspense = Suspense;
    exports.isAsyncMode = isAsyncMode;
    exports.isConcurrentMode = isConcurrentMode;
    exports.isContextConsumer = isContextConsumer;
    exports.isContextProvider = isContextProvider;
    exports.isElement = isElement;
    exports.isForwardRef = isForwardRef;
    exports.isFragment = isFragment;
    exports.isLazy = isLazy;
    exports.isMemo = isMemo;
    exports.isPortal = isPortal;
    exports.isProfiler = isProfiler;
    exports.isStrictMode = isStrictMode;
    exports.isSuspense = isSuspense;
    exports.isValidElementType = isValidElementType;
    exports.typeOf = typeOf;
      })();
    }
    });

    var reactIs = createCommonjsModule(function (module) {

    if (process.env.NODE_ENV === 'production') {
      module.exports = reactIs_production_min;
    } else {
      module.exports = reactIs_development;
    }
    });

    /**
     * Copyright 2015, Yahoo! Inc.
     * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
     */
    var REACT_STATICS = {
      childContextTypes: true,
      contextType: true,
      contextTypes: true,
      defaultProps: true,
      displayName: true,
      getDefaultProps: true,
      getDerivedStateFromError: true,
      getDerivedStateFromProps: true,
      mixins: true,
      propTypes: true,
      type: true
    };
    var KNOWN_STATICS = {
      name: true,
      length: true,
      prototype: true,
      caller: true,
      callee: true,
      arguments: true,
      arity: true
    };
    var FORWARD_REF_STATICS = {
      '$$typeof': true,
      render: true,
      defaultProps: true,
      displayName: true,
      propTypes: true
    };
    var MEMO_STATICS = {
      '$$typeof': true,
      compare: true,
      defaultProps: true,
      displayName: true,
      propTypes: true,
      type: true
    };
    var TYPE_STATICS = {};
    TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;
    TYPE_STATICS[reactIs.Memo] = MEMO_STATICS;

    function getStatics(component) {
      // React v16.11 and below
      if (reactIs.isMemo(component)) {
        return MEMO_STATICS;
      } // React v16.12 and above


      return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
    }

    var defineProperty = Object.defineProperty;
    var getOwnPropertyNames = Object.getOwnPropertyNames;
    var getOwnPropertySymbols = Object.getOwnPropertySymbols;
    var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
    var getPrototypeOf = Object.getPrototypeOf;
    var objectPrototype = Object.prototype;
    function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
      if (typeof sourceComponent !== 'string') {
        // don't hoist over string (html) components
        if (objectPrototype) {
          var inheritedComponent = getPrototypeOf(sourceComponent);

          if (inheritedComponent && inheritedComponent !== objectPrototype) {
            hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
          }
        }

        var keys = getOwnPropertyNames(sourceComponent);

        if (getOwnPropertySymbols) {
          keys = keys.concat(getOwnPropertySymbols(sourceComponent));
        }

        var targetStatics = getStatics(targetComponent);
        var sourceStatics = getStatics(sourceComponent);

        for (var i = 0; i < keys.length; ++i) {
          var key = keys[i];

          if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
            var descriptor = getOwnPropertyDescriptor(sourceComponent, key);

            try {
              // Avoid failures from read-only properties
              defineProperty(targetComponent, key, descriptor);
            } catch (e) {}
          }
        }
      }

      return targetComponent;
    }

    var hoistNonReactStatics_cjs = hoistNonReactStatics;

    function mapProps() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return function (target) {
            return Formily.ReactiveReact.observer(function (props) {
                var field = useField();
                var results = args.reduce(function (props, mapper) {
                    if (Formily.Shared.isFn(mapper)) {
                        props = Object.assign(props, mapper(props, field));
                    }
                    else {
                        Formily.Shared.each(mapper, function (to, extract) {
                            var extractValue = Formily.Shared.FormPath.getIn(field, extract);
                            var targetValue = Formily.Shared.isStr(to) ? to : extract;
                            var originalValue = Formily.Shared.FormPath.getIn(props, targetValue);
                            if (extract === 'value') {
                                if (to !== extract) {
                                    delete props.value;
                                }
                            }
                            if (Formily.Shared.isValid(originalValue) && !Formily.Shared.isValid(extractValue))
                                return;
                            Formily.Shared.FormPath.setIn(props, targetValue, extractValue);
                        });
                    }
                    return props;
                }, __assign({}, props));
                return React.createElement(target, results);
            }, {
                forwardRef: true,
            });
        };
    }
    function mapReadPretty(component) {
        return function (target) {
            return Formily.ReactiveReact.observer(function (props) {
                var field = useField();
                return React.createElement(!Formily.Core.isVoidField(field) && (field === null || field === void 0 ? void 0 : field.pattern) === 'readPretty'
                    ? component
                    : target, props);
            }, {
                forwardRef: true,
            });
        };
    }
    function connect(target) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var Target = args.reduce(function (target, mapper) {
            return mapper(target);
        }, target);
        var Destination = React.forwardRef(function (props, ref) {
            return React.createElement(Target, __assign(__assign({}, props), { ref: ref }));
        });
        if (target)
            hoistNonReactStatics_cjs(Destination, target);
        return Destination;
    }
    const _global_Formily_ReactiveReact_observer = Formily.ReactiveReact.observer;

    var FormProvider = function (props) {
        var form = useAttach(props.form);
        return (React.createElement(ContextCleaner, null,
            React.createElement(FormContext.Provider, { value: form }, props.children)));
    };
    FormProvider.displayName = 'FormProvider';

    var FormConsumer = Formily.ReactiveReact.observer(function (props) {
        var children = Formily.Shared.isFn(props.children) ? props.children(useForm()) : null;
        return React.createElement(React.Fragment, null, children);
    });
    FormConsumer.displayName = 'FormConsumer';

    var ReactiveInternal = function (props) {
        if (!props.field) {
            return (React.createElement(React.Fragment, null, Formily.Shared.isFn(props.children) ? props.children(null, null) : props.children));
        }
        var field = props.field;
        var children = Formily.Shared.isFn(props.children)
            ? props.children(props.field, props.field.form)
            : props.children;
        if (field.display !== 'visible')
            return null;
        var renderDecorator = function (children) {
            var _a;
            if (!field.decorator[0]) {
                return React.createElement(React.Fragment, null, children);
            }
            return React.createElement(field.decorator[0], __assign(__assign({}, field.decorator[1]), { style: __assign({}, (_a = field.decorator[1]) === null || _a === void 0 ? void 0 : _a.style) }), children);
        };
        var renderComponent = function () {
            var _a, _b, _c, _d;
            if (!field.component[0])
                return React.createElement(React.Fragment, null, children);
            var value = !Formily.Core.isVoidField(field) ? field.value : undefined;
            var onChange = !Formily.Core.isVoidField(field)
                ? function () {
                    var _a, _b;
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    field.onInput.apply(field, __spread(args));
                    (_b = (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onChange) === null || _b === void 0 ? void 0 : _b.call.apply(_b, __spread([_a], args));
                }
                : (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onChange;
            var onFocus = !Formily.Core.isVoidField(field)
                ? function () {
                    var _a, _b;
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    field.onFocus.apply(field, __spread(args));
                    (_b = (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onFocus) === null || _b === void 0 ? void 0 : _b.call.apply(_b, __spread([_a], args));
                }
                : (_b = field.component[1]) === null || _b === void 0 ? void 0 : _b.onFocus;
            var onBlur = !Formily.Core.isVoidField(field)
                ? function () {
                    var _a, _b;
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    field.onBlur.apply(field, __spread(args));
                    (_b = (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onBlur) === null || _b === void 0 ? void 0 : _b.call.apply(_b, __spread([_a], args));
                }
                : (_c = field.component[1]) === null || _c === void 0 ? void 0 : _c.onBlur;
            var disabled = !Formily.Core.isVoidField(field)
                ? field.pattern === 'disabled' || field.pattern === 'readPretty'
                : undefined;
            var readOnly = !Formily.Core.isVoidField(field)
                ? field.pattern === 'readOnly'
                : undefined;
            return React.createElement(field.component[0], __assign(__assign({ disabled: disabled,
                readOnly: readOnly }, field.component[1]), { style: __assign({}, (_d = field.component[1]) === null || _d === void 0 ? void 0 : _d.style), value: value,
                onChange: onChange,
                onFocus: onFocus,
                onBlur: onBlur }), children);
        };
        return renderDecorator(renderComponent());
    };
    ReactiveInternal.displayName = 'ReactiveField';
    var ReactiveField = Formily.ReactiveReact.observer(ReactiveInternal, {
        forwardRef: true,
    });

    var ArrayField = function (props) {
        var form = useForm();
        var parent = useField();
        var field = useAttach(form.createArrayField(__assign({ basePath: parent === null || parent === void 0 ? void 0 : parent.address }, props)));
        return (React.createElement(FieldContext.Provider, { value: field },
            React.createElement(ReactiveField, { field: field }, props.children)));
    };
    ArrayField.displayName = 'ArrayField';

    var ObjectField = function (props) {
        var form = useForm();
        var parent = useField();
        var field = useAttach(form.createObjectField(__assign({ basePath: parent === null || parent === void 0 ? void 0 : parent.address }, props)));
        return (React.createElement(FieldContext.Provider, { value: field },
            React.createElement(ReactiveField, { field: field }, props.children)));
    };
    ObjectField.displayName = 'ObjectField';

    var VoidField = function (props) {
        var form = useForm();
        var parent = useField();
        var field = useAttach(form.createVoidField(__assign({ basePath: parent === null || parent === void 0 ? void 0 : parent.address }, props)));
        return (React.createElement(FieldContext.Provider, { value: field },
            React.createElement(ReactiveField, { field: field }, props.children)));
    };
    VoidField.displayName = 'VoidField';

    var Field = function (props) {
        var form = useForm();
        var parent = useField();
        var field = useAttach(form.createField(__assign({ basePath: parent === null || parent === void 0 ? void 0 : parent.address }, props)));
        return (React.createElement(FieldContext.Provider, { value: field },
            React.createElement(ReactiveField, { field: field }, props.children)));
    };
    Field.displayName = 'Field';

    var RecursionField = function (props) {
        var schema = new Formily.JSONSchema.Schema(props.schema);
        var parent = useField();
        var options = React.useContext(SchemaOptionsContext);
        var scope = React.useContext(SchemaExpressionScopeContext);
        var fieldSchema = React.useMemo(function () {
            return schema === null || schema === void 0 ? void 0 : schema.compile(__assign(__assign({}, options.scope), scope));
        }, [schema]);
        var fieldProps = React.useMemo(function () { return fieldSchema === null || fieldSchema === void 0 ? void 0 : fieldSchema.toFieldProps(options); }, [fieldSchema]);
        var getBasePath = function () {
            if (props.onlyRenderProperties) {
                return props.basePath || (parent === null || parent === void 0 ? void 0 : parent.address.concat(props.name));
            }
            return props.basePath || (parent === null || parent === void 0 ? void 0 : parent.address);
        };
        var basePath = getBasePath();
        var renderProperties = function (field) {
            if (props.onlyRenderSelf)
                return;
            return (React.createElement(React.Fragment, null,
                fieldSchema.mapProperties(function (item, name, index) {
                    var base = (field === null || field === void 0 ? void 0 : field.address) || basePath;
                    var schema = item;
                    if (Formily.Shared.isFn(props.mapProperties)) {
                        var mapped = props.mapProperties(item, name);
                        if (mapped) {
                            schema = mapped;
                        }
                    }
                    if (Formily.Shared.isFn(props.filterProperties)) {
                        if (props.filterProperties(schema, name) === false) {
                            return null;
                        }
                    }
                    return (React.createElement(RecursionField, { schema: schema, key: index, name: name, basePath: base }));
                }),
                fieldSchema['x-content']));
        };
        var render = function () {
            var _a;
            if (!Formily.Shared.isValid(props.name))
                return renderProperties();
            if (fieldSchema.type === 'object') {
                if (props.onlyRenderProperties)
                    return renderProperties();
                return (React.createElement(ObjectField, __assign({}, fieldProps, { name: props.name, basePath: basePath }), renderProperties));
            }
            else if (fieldSchema.type === 'array') {
                return (React.createElement(ArrayField, __assign({}, fieldProps, { name: props.name, basePath: basePath })));
            }
            else if (fieldSchema.type === 'void') {
                if (props.onlyRenderProperties)
                    return renderProperties();
                return (React.createElement(VoidField, __assign({}, fieldProps, { name: props.name, basePath: basePath }), renderProperties));
            }
            return (React.createElement(Field, __assign({}, fieldProps, { name: props.name, basePath: basePath }), fieldSchema['x-content'] || ((_a = fieldSchema['x-component-props']) === null || _a === void 0 ? void 0 : _a['children'])));
        };
        if (!fieldSchema)
            return React.createElement(React.Fragment, null);
        return (React.createElement(SchemaContext.Provider, { value: fieldSchema }, render()));
    };

    var env$1 = {
        portalDOM: null,
    };
    var render = function (element) {
        if (Formily.Shared.globalThisPolyfill['document']) {
            env$1.portalDOM =
                env$1.portalDOM || Formily.Shared.globalThisPolyfill['document'].createElement('div');
            return ReactDOM.createPortal(element, env$1.portalDOM);
        }
        else {
            return React.createElement('template', {}, element);
        }
    };

    var env = {
        nonameId: 0,
    };
    var getRandomName = function () {
        return "NO_NAME_FIELD_$" + env.nonameId++;
    };
    function createSchemaField(options) {
        if (options === void 0) { options = {}; }
        function SchemaField(props) {
            var schema = Formily.JSONSchema.Schema.isSchemaInstance(props.schema)
                ? props.schema
                : new Formily.JSONSchema.Schema(__assign({ type: 'object' }, props.schema));
            var renderMarkup = function () {
                env.nonameId = 0;
                return render(React.createElement(SchemaMarkupContext.Provider, { value: schema }, props.children));
            };
            var renderChildren = function () {
                return React.createElement(RecursionField, __assign({}, props, { schema: schema }));
            };
            return (React.createElement(SchemaOptionsContext.Provider, { value: __assign(__assign({}, options), { components: __assign(__assign({}, options.components), props.components) }) },
                React.createElement(SchemaExpressionScopeContext.Provider, { value: __assign(__assign({}, options.scope), props.scope) },
                    renderMarkup(),
                    renderChildren())));
        }
        SchemaField.displayName = 'SchemaField';
        function MarkupField(props) {
            var parent = React.useContext(SchemaMarkupContext);
            if (!parent)
                return React.createElement(React.Fragment, null);
            var renderChildren = function () {
                return React.createElement(React.Fragment, null, props.children);
            };
            var appendArraySchema = function (schema) {
                if (parent.items) {
                    return parent.addProperty(name, schema);
                }
                else {
                    return parent.setItems(props);
                }
            };
            var name = props.name || getRandomName();
            if (parent.type === 'object' || parent.type === 'void') {
                var schema = parent.addProperty(name, props);
                return (React.createElement(SchemaMarkupContext.Provider, { value: schema }, renderChildren()));
            }
            else if (parent.type === 'array') {
                var schema = appendArraySchema(props);
                return (React.createElement(SchemaMarkupContext.Provider, { value: Array.isArray(schema) ? schema[0] : schema }, props.children));
            }
            else {
                return renderChildren();
            }
        }
        MarkupField.displayName = 'MarkupField';
        function StringField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "string" }));
        }
        StringField.displayName = 'StringField';
        function ObjectField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "object" }));
        }
        ObjectField.displayName = 'ObjectField';
        function ArrayField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "array" }));
        }
        ArrayField.displayName = 'ArrayField';
        function BooleanField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "boolean" }));
        }
        BooleanField.displayName = 'BooleanField';
        function NumberField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "number" }));
        }
        NumberField.displayName = 'NumberField';
        function DateField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "date" }));
        }
        DateField.displayName = 'DateField';
        function DateTimeField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "datetime" }));
        }
        DateTimeField.displayName = 'DateTimeField';
        function VoidField(props) {
            return React.createElement(MarkupField, __assign({}, props, { type: "void" }));
        }
        VoidField.displayName = 'VoidField';
        SchemaField.Markup = MarkupField;
        SchemaField.String = StringField;
        SchemaField.Object = ObjectField;
        SchemaField.Array = ArrayField;
        SchemaField.Boolean = BooleanField;
        SchemaField.Date = DateField;
        SchemaField.DateTime = DateTimeField;
        SchemaField.Void = VoidField;
        SchemaField.Number = NumberField;
        return SchemaField;
    }

    exports.ArrayField = ArrayField;
    exports.ContextCleaner = ContextCleaner;
    exports.Field = Field;
    exports.FieldContext = FieldContext;
    exports.FormConsumer = FormConsumer;
    exports.FormContext = FormContext;
    exports.FormProvider = FormProvider;
    exports.ObjectField = ObjectField;
    exports.RecursionField = RecursionField;
    exports.Schema = Schema;
    exports.SchemaContext = SchemaContext;
    exports.SchemaExpressionScopeContext = SchemaExpressionScopeContext;
    exports.SchemaMarkupContext = SchemaMarkupContext;
    exports.SchemaOptionsContext = SchemaOptionsContext;
    exports.VoidField = VoidField;
    exports.connect = connect;
    exports.createSchemaField = createSchemaField;
    exports.mapProps = mapProps;
    exports.mapReadPretty = mapReadPretty;
    exports.observer = _global_Formily_ReactiveReact_observer;
    exports.useField = useField;
    exports.useFieldSchema = useFieldSchema;
    exports.useForm = useForm;
    exports.useFormEffects = useFormEffects;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
