"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactiveField = void 0;
var react_1 = __importStar(require("react"));
var reactive_react_1 = require("@formily/reactive-react");
var shared_1 = require("@formily/shared");
var core_1 = require("@formily/core");
var ReactiveInternal = function (props) {
    if (!props.field) {
        return (react_1.default.createElement(react_1.Fragment, null, shared_1.isFn(props.children) ? props.children(null, null) : props.children));
    }
    var field = props.field;
    var children = shared_1.isFn(props.children)
        ? props.children(props.field, props.field.form)
        : props.children;
    if (field.display !== 'visible')
        return null;
    var renderDecorator = function (children) {
        var _a;
        if (!field.decorator[0]) {
            return react_1.default.createElement(react_1.Fragment, null, children);
        }
        return react_1.default.createElement(field.decorator[0], __assign(__assign({}, field.decorator[1]), { style: __assign({}, (_a = field.decorator[1]) === null || _a === void 0 ? void 0 : _a.style) }), children);
    };
    var renderComponent = function () {
        var _a, _b, _c, _d;
        if (!field.component[0])
            return react_1.default.createElement(react_1.Fragment, null, children);
        var value = !core_1.isVoidField(field) ? field.value : undefined;
        var onChange = !core_1.isVoidField(field)
            ? function () {
                var _a, _b;
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                field.onInput.apply(field, __spread(args));
                (_b = (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onChange) === null || _b === void 0 ? void 0 : _b.call.apply(_b, __spread([_a], args));
            }
            : (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onChange;
        var onFocus = !core_1.isVoidField(field)
            ? function () {
                var _a, _b;
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                field.onFocus.apply(field, __spread(args));
                (_b = (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onFocus) === null || _b === void 0 ? void 0 : _b.call.apply(_b, __spread([_a], args));
            }
            : (_b = field.component[1]) === null || _b === void 0 ? void 0 : _b.onFocus;
        var onBlur = !core_1.isVoidField(field)
            ? function () {
                var _a, _b;
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                field.onBlur.apply(field, __spread(args));
                (_b = (_a = field.component[1]) === null || _a === void 0 ? void 0 : _a.onBlur) === null || _b === void 0 ? void 0 : _b.call.apply(_b, __spread([_a], args));
            }
            : (_c = field.component[1]) === null || _c === void 0 ? void 0 : _c.onBlur;
        var disabled = !core_1.isVoidField(field)
            ? field.pattern === 'disabled' || field.pattern === 'readPretty'
            : undefined;
        var readOnly = !core_1.isVoidField(field)
            ? field.pattern === 'readOnly'
            : undefined;
        return react_1.default.createElement(field.component[0], __assign(__assign({ disabled: disabled,
            readOnly: readOnly }, field.component[1]), { style: __assign({}, (_d = field.component[1]) === null || _d === void 0 ? void 0 : _d.style), value: value,
            onChange: onChange,
            onFocus: onFocus,
            onBlur: onBlur }), children);
    };
    return renderDecorator(renderComponent());
};
ReactiveInternal.displayName = 'ReactiveField';
exports.ReactiveField = reactive_react_1.observer(ReactiveInternal, {
    forwardRef: true,
});
